
Core - Task # 55573

Epic # 55070 (Accepted): Workpackages
Epic # 54851 (Accepted): WP: Workspaces IRRE & MM bugfixes
Story # 54853 (Accepted): As a user I want to correctly create, modify, preview and publish IRRE & MM related workspace changes

Status: Resolved Priority: Should have
Author: Oliver Hader Category: Workspaces
Created: 2014-02-02 Assigned To: Oliver Hader
Updated: 2014-02-20 Due date:
TYPO3 Version: 6.2
PHP Version: 5.3
Complexity:
Sprint Focus:
Subject: Failing moveContentRecordToDifferentPageAndChangeSorting
Description

TYPO3\CMS\Workspaces\Tests\Functional\DataHandling\Regular::moveContentRecordToDifferentPageAndChangeSorting fails (see
#55563)

In a workspace, an existing content record is moved to an existing page. Another existing record is moved after the previously moved
record on the target page. The Functional Tests show, that the content records are faulty after the processing and the first content
record disappeared.

Related issues:
related to Core - Bug # 33104: create/move initial-placeholder page behind mo... Resolved 2012-01-11
related to Core - Task # 55563: Add functional test cases to DataHandler for ... Resolved 2014-02-01
related to Core - Bug # 53619: Moving Elements in draft - now my live is a mess New 2013-11-13
duplicated by Core - Bug # 55768: Drag & drop in Workspaces moves live page Resolved 2014-02-07

Associated revisions
Revision aa5804dd - 2014-02-20 17:27 - Oliver Hader

[BUGFIX] moveContentRecordToDifferentPageAndChangeSorting fails

In a workspace, an existing content record is moved to an
existing page. Another existing record is moved after the
previously moved record on the target page. The Functional
Tests show, that the content records are faulty after the
processing and the first content record disappeared.

A similar behaviour has been discovered for pages which finally
lead to the regression causing this bug in issue #33104. Back
then a hook has been introduced for moving page records and
post-processing the database values. However, this hook has
been called for all move operations for any table and was wrong
in terms of the expected specific problem to be solved.

The hook gets reverted, since it's sufficient to resolve move
placeholders if a record shall be created after an existing one.

Resolves: #55573
Releases: 6.2
Change-Id: Ie5cbc95daf4d46f4204cf18e80e17ff4fa37f496
Reviewed-on: https://review.typo3.org/27733
Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters
Reviewed-by: Oliver Hader
Tested-by: Oliver Hader

History
#1 - 2014-02-19 15:37 - Oliver Hader
- Assigned To set to Oliver Hader
- Parent task set to #54853

#2 - 2014-02-19 17:49 - Oliver Hader
- Is Regression changed from No to Yes

#3 - 2014-02-19 17:50 - Oliver Hader

The behaviour is caused by #33104 which has a wrong fix and seems to be related to pages only (but affects currently all tables)

#4 - 2014-02-19 20:58 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27733

#5 - 2014-02-19 21:16 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/27733

#6 - 2014-02-19 22:21 - Oliver Hader

A similar behaviour has been discovered for pages which finally lead to the regression causing this bug in issue #33104. Back then a hook has been
introduced for moving page records and post-processing the database values. However, this hook has been called for all move operations for any table
and was wrong in terms of the expected specific problem to be solved.

The hook gets reverted, since it's sufficient to resolve move placeholders if a record shall be created after an existing one.

The problem scenario back then was like this:
Page structure:
    -  root
        -  Y
            -  X
            -  M
        -  A
Actions:
    -  moving page "M" to page "A" 
    -  creating new page "N" after moved page "M" ("pid=-M")
The result was, that the new page "N" has been added as sub-page of "Y", the location of page "M" before it was moved. Thus, the move-placeholder
just was not considered.

#7 - 2014-02-20 17:30 - Oliver Hader
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:aa5804ddb098c9bbfa967d75000b0e3f06bff408.
